%define major   3
%define libname %mklibname %{name} %{major}
%define devname %mklibname %{name} -d

# build deprecated tools
# hciattach hciconfig hcitool hcidump rfcomm sdptool ciptool gatttool
%bcond_without deprecated

Name:           bluez
Summary:        Official Linux Bluetooth protocol stack
Version:        5.55
%define subrel 6
Release:        %mkrel 3
License:        GPLv2+
Group:          Communications/Bluetooth
URL:            http://www.bluez.org/
Source0:        https://www.kernel.org/pub/linux/bluetooth/%{name}-%{version}.tar.xz

## Ubuntu patches
Patch1:         0001-work-around-Logitech-diNovo-Edge-keyboard-firmware-i.patch
# Non-upstream
Patch2:         0001-Allow-using-obexd-without-systemd-in-the-user-sessio.patch
Patch3:         0001-obex-Use-GLib-helper-function-to-manipulate-paths.patch
Patch5:         0004-agent-Assert-possible-infinite-loop.patch
Patch6:         main-Dont-warn-for-unset-config-option.patch
Patch102:       CVE-2016-9804-tool-hcidump-Fix-memory-leak-with-malformed-packet.patch
Patch103:       CVE-2020-26558.patch
Patch104:       CVE-2021-3588.patch
Patch105:       0001-adapter-Fix-storing-discoverable-setting.patch
Patch106:       CVE-2021-41229.patch
Patch107:       CVE-2021-43400-pre2.patch
Patch108:       CVE-2021-43400.patch
Patch109:       CVE-2022-0204.patch
Patch110:       avdtp-security.patch
Patch111:       avdtp-security-2.patch
Patch112:       avrcp-security.patch

BuildRequires:  flex
BuildRequires:  bison
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(ell) >= 0.26
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(libcap-ng)
BuildRequires:  pkgconfig(libical)
BuildRequires:  readline-devel
BuildRequires:  pkgconfig(systemd)
BuildRequires:  pkgconfig(udev)
Requires(pre):  filesystem >= 2.1.9-18
Requires(post): rpm-helper >= 0.24.8-1
Requires(preun):        rpm-helper >= 0.24.8-1
Recommends:     bluez-firmware

%description
These are the official Bluetooth communication libraries for Linux.

%post
%_post_service bluetooth

%preun
%_preun_service bluetooth

%files
%config %{_sysconfdir}/dbus-1/system.d/bluetooth.conf
%config %{_sysconfdir}/bluetooth/*.conf
%config %{_sysconfdir}/bluetooth/pin
%{_bindir}/btattach
%{_bindir}/l2ping
%{_bindir}/bccmd
%{_bindir}/bluetoothctl
%{_bindir}/bluemoon
%{_bindir}/btmon
%if %{with deprecated}
%{_bindir}/hciattach
%{_bindir}/hciconfig
%{_bindir}/hcitool
%{_bindir}/hcidump
%{_bindir}/rfcomm
%{_bindir}/sdptool
%{_bindir}/ciptool
%{_mandir}/man1/hciattach.1.*
%{_mandir}/man1/hciconfig.1.*
%{_mandir}/man1/hcitool.1.*
%{_mandir}/man1/hcidump.1.*
%{_mandir}/man1/rfcomm.1.*
%{_mandir}/man1/sdptool.1.*
%{_mandir}/man1/ciptool.1.*
%endif
%{_bindir}/hex2hcd
%{_bindir}/l2test
%{_bindir}/mpris-proxy
%{_bindir}/rctest
%{_mandir}/man1/btattach.1.*
%{_mandir}/man1/bccmd.1.*
%{_mandir}/man1/l2ping.1.*
%{_mandir}/man1/rctest.1.*
%{_mandir}/man8/*
%{_libexecdir}/bluetooth/bluetoothd
%{_libexecdir}/bluetooth/obexd
%{_libdir}/bluetooth
%{_localstatedir}/lib/bluetooth
%{_datadir}/dbus-1/system-services/org.bluez.service
%{_datadir}/dbus-1/services/org.bluez.obex.service
%{_datadir}/zsh/site-functions/_bluetoothctl
%{_unitdir}/bluetooth.service
%{_userunitdir}/obex.service
%{_userunitdir}/dbus-org.bluez.obex.service

#--------------------------------------------------------------------

%package        cups
Summary:        CUPS printer backend for Bluetooth printers
Group:          System/Printing
Requires:       cups-filesystem
BuildRequires:  cups-devel

%description    cups
This package contains the CUPS backend for Bluetooth printers.

%files cups
%{_prefix}/lib/cups/backend/bluetooth

#--------------------------------------------------------------------

%package        mesh
Summary:        Bluetooth mesh
Group:          Communications/Bluetooth
BuildRequires:  pkgconfig(json-c)
Requires:       %{name} >= %{version}-%{release}

%description    mesh
This package contains the Services for bluetooth mesh.

%post mesh
%_post_service bluetooth-mesh

%preun mesh
%_preun_service bluetooth-mesh

%files mesh
%{_sysconfdir}/dbus-1/system.d/bluetooth-mesh.conf
%{_bindir}/meshctl
%{_bindir}/mesh-cfgclient
%{_unitdir}/bluetooth-mesh.service
%{_libexecdir}/bluetooth/bluetooth-meshd
%{_datadir}/dbus-1/system-services/org.bluez.mesh.service

#--------------------------------------------------------------------

%package        hid2hci
Summary:        Put HID proxying bluetooth HCI's into HCI mode
Group:          Communications/Bluetooth
Conflicts:      %{name} < 4.99-1
Requires(post): filesystem >= 2.1.9-18

%description    hid2hci
Most allinone PC's and bluetooth keyboard / mouse sets which include a
bluetooth dongle, ship with a so called HID proxying bluetooth HCI.
The HID proxying makes the keyboard / mouse show up as regular USB HID
devices (after connecting using the connect button on the device + keyboard),
which makes them work without requiring any manual configuration.

The bluez-hid2hci package contains the hid2hci utility and udev rules to
automatically switch supported Bluetooth devices into regular HCI mode.

Install this package if you want to use the bluetooth function of the HCI
with other bluetooth devices like for example a mobile phone.

Note that after installing this package you will first need to pair your
bluetooth keyboard and mouse with the bluetooth adapter before you can use
them again. Since you cannot use your bluetooth keyboard and mouse until
they are paired, this will require the use of a regular (wired) USB keyboard
and mouse.

%files hid2hci
%{_prefix}/lib/udev/hid2hci
%{_mandir}/man1/hid2hci.1*
%{_udevrulesdir}/97-hid2hci.rules

%post hid2hci
%{_bindir}/udevadm trigger --subsystem-match=usb

#--------------------------------------------------------------------

%package -n     %{libname}
Summary:        Official Linux Bluetooth protocol stack
Group:          System/Libraries
Requires(pre):  filesystem >= 2.1.9-18

%description -n %{libname}
These are the official Bluetooth communication libraries for Linux.

%files -n %{libname}
%{_libdir}/lib*.so.%{major}{,.*}

#--------------------------------------------------------------------

%package -n     %{devname}
Summary:        Headers for developing programs that will use %{name}
Group:          Development/C++
Requires(pre):  filesystem >= 2.1.9-18
Requires:       %{libname} = %{version}
Provides:       lib%{name}-devel = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{devname}
This package contains the headers that programmers will need to develop
applications which will use libraries from %{name}.

%files -n %{devname}
%doc AUTHORS ChangeLog README
%{_includedir}/bluetooth
%{_libdir}/*.so
%{_libdir}/pkgconfig/bluez.pc

#--------------------------------------------------------------------

%prep
%setup -q
%autopatch -p1

%build
autoreconf -fi
%configure \
    --enable-cups \
    --enable-tools \
    --enable-library \
    --enable-sixaxis \
    --enable-hid2hci \
    --enable-nfc \
    --enable-mesh \
    %{?with_deprecated:--enable-deprecated} \
    --with-systemdsystemunitdir=%{_unitdir} \
    --with-systemduserunitdir=%{_userunitdir}

%make_build

%install
%make_install

# Remove the cups backend from libdir, and install it in /usr/lib whatever the install
%ifarch x86_64 aarch64
if test -d %{buildroot}%{_libdir}/cups ; then
    install -D -m0755 %{buildroot}%{_libdir}/cups/backend/bluetooth %{buildroot}/usr/lib/cups/backend/bluetooth
    rm -rf %{buildroot}%{_libdir}/cups
fi
%endif

rm -f %{buildroot}%{_sysconfdir}/udev/*.rules
rm -f %{buildroot}/usr/lib/udev/rules.d/*.rules
install -D -p -m0644 tools/hid2hci.rules \
    %{buildroot}%{_udevrulesdir}/97-hid2hci.rules

#install more config files
install -d -m 755 %{buildroot}%{_sysconfdir}/bluetooth

echo "1234" > %{buildroot}%{_sysconfdir}/bluetooth/pin
chmod 600 %{buildroot}%{_sysconfdir}/bluetooth/pin

install -m 644 profiles/network/network.conf %{buildroot}%{_sysconfdir}/bluetooth/
install -m 644 profiles/input/input.conf %{buildroot}%{_sysconfdir}/bluetooth/

#copy bluetooth config file and setup auto enable
install -D -p -m0644 src/main.conf %{buildroot}%{_sysconfdir}/bluetooth/main.conf
install -D -p -m0644 mesh/mesh-main.conf %{buildroot}%{_sysconfdir}/bluetooth/mesh-main.conf
sed -i 's/#\[Policy\]$/\[Policy\]/; s/#AutoEnable=false/AutoEnable=true/' %{buildroot}%{_sysconfdir}/bluetooth/main.conf

# remove unpackaged files
find %{buildroot} -name '*.la' -delete

install -d -m0755 %{buildroot}%{_localstatedir}/lib/bluetooth

# We need to ensure obexd can be spawned automatically by systemd
# when user-session is enabled:
# https://bugs.gentoo.org/show_bug.cgi?id=577842
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=804908
# https://bugs.archlinux.org/task/45816
# https://bugzilla.redhat.com/show_bug.cgi?id=1318441
# https://bugzilla.redhat.com/show_bug.cgi?id=1389347
ln -s %{_userunitdir}/obex.service %{buildroot}%{_userunitdir}/dbus-org.bluez.obex.service


%changelog
* Sat Jul 09 2022 wally <wally> 5.55-3.6.mga8
+ Revision: 1868149
- enable hid2hci again (mga#30617)

* Fri Jun 17 2022 ns80 <ns80> 5.55-3.5.mga8
+ Revision: 1864679
- add patches from Ubuntu for new security issues (mga#30556)

* Wed Feb 09 2022 ns80 <ns80> 5.55-3.4.mga8
+ Revision: 1772651
- add patch from Ubuntu for CVE-2022-0204 (mga#30015)

* Thu Nov 25 2021 ns80 <ns80> 5.55-3.3.mga8
+ Revision: 1759156
- add patches from Ubuntu for CVE-2021-41229 and CVE-2021-43400 (mga#29694)

* Mon Aug 02 2021 ns80 <ns80> 5.55-3.2.mga8
+ Revision: 1738627
- add patch from Fedora for CVE-2021-3658 (mga#29323)

* Fri Jun 18 2021 ns80 <ns80> 5.55-3.1.mga8
+ Revision: 1731106
- add patches for CVE-2020-26558 and CVE-2021-3588 (mga#29140)

* Sun Feb 14 2021 tmb <tmb> 5.55-3.mga8
+ Revision: 1675389
- main: Don't warn for unset config option (mga#27314)
+ pterjan <pterjan>
- Fix URL

* Mon Nov 30 2020 luigiwalser <luigiwalser> 5.55-2.mga8
+ Revision: 1650725
- rebuild for json-c

* Sat Sep 19 2020 shlomif <shlomif> 5.55-1.mga8
+ Revision: 1628735
- New version 5.55

* Sun Jul 12 2020 zezinho <zezinho> 5.54-2.mga8
+ Revision: 1605711
- add main.conf file

* Sun Mar 15 2020 daviddavid <daviddavid> 5.54-1.mga8
+ Revision: 1556524
- new version: 5.54

* Wed Feb 19 2020 daviddavid <daviddavid> 5.53-1.mga8
+ Revision: 1544488
- new version: 5.53

* Tue Feb 18 2020 umeabot <umeabot> 5.52-3.mga8
+ Revision: 1542026
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sat Jan 04 2020 luigiwalser <luigiwalser> 5.52-2.mga8
+ Revision: 1475935
- rebuild for readline

* Wed Nov 20 2019 daviddavid <daviddavid> 5.52-1.mga8
+ Revision: 1461785
- new version: 5.52
- enable nfc and mesh support
- remove merged upstream patches

* Mon Aug 19 2019 daviddavid <daviddavid> 5.50-6.mga8
+ Revision: 1430311
- add upstream patch to fix build after y2038 changes in glibc

* Wed Mar 27 2019 wally <wally> 5.50-5.mga7
+ Revision: 1380654
- drop unneeded post scriptlets

* Wed Mar 27 2019 daviddavid <daviddavid> 5.50-4.mga7
+ Revision: 1380610
- ensure obexd can be spawned automatically by systemd when user-session is enabled (mga#19140)

* Mon Jan 21 2019 luigiwalser <luigiwalser> 5.50-3.mga7
+ Revision: 1358540
- add patches from opensuse to fix CVE-2016-980[014]

* Fri Sep 21 2018 umeabot <umeabot> 5.50-2.mga7
+ Revision: 1295553
- Mageia 7 Mass Rebuild

* Wed Jun 13 2018 shlomif <shlomif> 5.50-1.mga7
+ Revision: 1236795
- New version 5.50

* Tue Apr 10 2018 tv <tv> 5.49-2.mga7
+ Revision: 1216895
- rebuild for new libicalvcal

* Wed Mar 14 2018 shlomif <shlomif> 5.49-1.mga7
+ Revision: 1209444
- New version 5.49

* Sat Jan 27 2018 shlomif <shlomif> 5.48-1.mga7
+ Revision: 1197418
- New version 5.48 (Gentoo)

* Wed Oct 25 2017 shlomif <shlomif> 5.47-1.mga7
+ Revision: 1173621
- New version 5.47

* Thu Sep 14 2017 shlomif <shlomif> 5.45-3.mga7
+ Revision: 1153776
- Add patch for MGA#21698 .

* Tue May 23 2017 luigiwalser <luigiwalser> 5.45-2.mga6
+ Revision: 1104152
- rebuild for core/release

* Tue May 16 2017 luigiwalser <luigiwalser> 5.45-1.mga6
+ Revision: 1102213
- 5.45

* Thu Mar 30 2017 luigiwalser <luigiwalser> 5.44-1.mga6
+ Revision: 1095296
- 5.44

* Fri Nov 04 2016 luigiwalser <luigiwalser> 5.43-1.mga6
+ Revision: 1065335
- 5.43
- remove patch6 (fixed upstream)

* Wed Oct 26 2016 luigiwalser <luigiwalser> 5.42-1.mga6
+ Revision: 1063599
- 5.42
- add patch to fix OBEX connections from fedora

* Tue Oct 04 2016 daviddavid <daviddavid> 5.41-3.mga6
+ Revision: 1058308
- ensure that the old broken dangling link will be removed from users system (mga#17682)
- add missing systemd preun_service

* Thu Aug 11 2016 shlomif <shlomif> 5.41-2.mga6
+ Revision: 1045548
- Bump the rel.
- Remove "bluepin" which was removed from upstream (MGA#19178).
- Some SPEC cleanups.

* Wed Aug 10 2016 luigiwalser <luigiwalser> 5.41-1.mga6
+ Revision: 1045262
- 5.41

* Mon May 09 2016 luigiwalser <luigiwalser> 5.39-1.mga6
+ Revision: 1011326
- 5.39

* Tue Jan 26 2016 luigiwalser <luigiwalser> 5.37-2.mga6
+ Revision: 927857
- rebuild for libical

* Thu Dec 31 2015 luigiwalser <luigiwalser> 5.37-1.mga6
+ Revision: 917375
- 5.37
- remove old obsoletes

* Tue Aug 25 2015 ycantin <ycantin> 5.33-1.mga6
+ Revision: 869406
- new version 5.33

* Sun Jun 21 2015 shlomif <shlomif> 5.31-1.mga6
+ Revision: 837743
- New version 5.31

* Fri Feb 13 2015 luigiwalser <luigiwalser> 5.28-1.mga5
+ Revision: 814854
- 5.28
- remove upstreamed patch
- update files list

* Fri Jan 09 2015 luigiwalser <luigiwalser> 5.27-1.mga5
+ Revision: 809619
- 5.27
- add patch to fix format security error

* Fri Dec 12 2014 luigiwalser <luigiwalser> 5.26-1.mga5
+ Revision: 802806
- 5.26

* Thu Nov 20 2014 luigiwalser <luigiwalser> 5.25-1.mga5
+ Revision: 798015
- 5.25

* Wed Oct 15 2014 umeabot <umeabot> 5.24-2.mga5
+ Revision: 749893
- Second Mageia 5 Mass Rebuild

* Wed Oct 08 2014 luigiwalser <luigiwalser> 5.24-1.mga5
+ Revision: 737544
- 5.24

* Thu Sep 18 2014 umeabot <umeabot> 5.22-3.mga5
+ Revision: 693510
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 5.22-2.mga5
+ Revision: 678184
- Mageia 5 Mass Rebuild
+ tv <tv>
- s/uggests:/Recommends:/

* Fri Sep 05 2014 luigiwalser <luigiwalser> 5.22-1.mga5
+ Revision: 672340
- 5.22 (fixes needed for kernel 3.17)

* Wed Jul 30 2014 guillomovitch <guillomovitch> 5.21-1.mga5
+ Revision: 658312
- new version 5.21

* Mon Jun 30 2014 guillomovitch <guillomovitch> 5.20-1.mga5
+ Revision: 641654
- new version 5.20

* Sat May 31 2014 guillomovitch <guillomovitch> 5.19-1.mga5
+ Revision: 628081
- new version 5.19

* Sun May 04 2014 shlomif <shlomif> 5.18-1.mga5
+ Revision: 619985
- New version 5.18

* Tue Mar 18 2014 guillomovitch <guillomovitch> 5.16-1.mga5
+ Revision: 605088
- new version 5.16

* Fri Mar 07 2014 guillomovitch <guillomovitch> 5.15-1.mga5
+ Revision: 600874
- new version 5.15

* Thu Feb 06 2014 guillomovitch <guillomovitch> 5.14-1.mga5
+ Revision: 584785
- new version 5.14

* Mon Dec 02 2013 guillomovitch <guillomovitch> 5.11-1.mga4
+ Revision: 554648
- new version 5.11

* Mon Oct 21 2013 umeabot <umeabot> 5.9-2.mga4
+ Revision: 540592
- Mageia 4 Mass Rebuild

* Wed Oct 09 2013 luigiwalser <luigiwalser> 5.9-1.mga4
+ Revision: 494050
- obsolete blueman and obex-data-server (not compatible with bluez5)
- 5.9
- add patch3 from fedora

* Tue Sep 03 2013 guillomovitch <guillomovitch> 5.8-1.mga4
+ Revision: 474897
- new version 5.0
- sync patchset with fedora package
- drop obsoletes configuration files
- don't ship test agent

* Thu Jun 13 2013 tv <tv> 4.101-6.mga4
+ Revision: 442868
- requires cups-filesystem instead of cups

* Fri Jan 11 2013 umeabot <umeabot> 4.101-5.mga3
+ Revision: 346925
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Dec 29 2012 cjw <cjw> 4.101-4.mga3
+ Revision: 336270
- patch0504: fix build with automake 1.13

* Wed Oct 03 2012 malo <malo> 4.101-3.mga3
+ Revision: 302586
- update RPM group

* Sat Jul 21 2012 colin <colin> 4.101-2.mga3
+ Revision: 273158
- Update for usrmove

* Fri Jun 29 2012 colin <colin> 4.101-1.mga3
+ Revision: 265009
- New version: 4.101
- Drop sysvinit only udev rule.
- Rebase patches (thanks to Fedora for updated sixaxis patch)
- Fix Build Requires
- Rebuild against new libudev major

* Sat Apr 28 2012 tmb <tmb> 4.99-3.mga2
+ Revision: 233611
- Require rpm-helper >= 0.24.8-1 for systemd support

* Fri Apr 27 2012 tmb <tmb> 4.99-2.mga2
+ Revision: 233515
- rebuild for versioned rpm-helper requires

* Sun Apr 08 2012 colin <colin> 4.99-1.mga2
+ Revision: 229743
- Split hid2hci into a subpackage to make it optional
- New version: 4.99

* Tue Mar 06 2012 colin <colin> 4.98-2.mga2
+ Revision: 219435
- Fix C++ build problems in bluetooth.h
- Fix obexd build problems in bluetooth.h
- Split up systemd patches for (hopefully) future upstreaming
- Prevent double logging in systemd journal

* Mon Mar 05 2012 colin <colin> 4.98-1.mga2
+ Revision: 219189
- New version 4.98
- Rediff patches
- Rewrite systemd patch to fixup committed systemd support.
+ dmorgan <dmorgan>
- Remove %%_postun_service macro, this is now handled by filetriggers

* Sat Dec 24 2011 dmorgan <dmorgan> 4.96-5.mga2
+ Revision: 187180
- Fix systemd support

* Sat Dec 24 2011 dmorgan <dmorgan> 4.96-4.mga2
+ Revision: 187168
- Handle systemd services at install now ( mga #3867)

* Sat Dec 17 2011 colin <colin> 4.96-3.mga2
+ Revision: 183014
- Add patches from Fedora for device compatibiliy + systemd integration.
- Move udev rules to /lib/udev/rules.d rather than /etc/
- Fix some minor space+tab inconsistencies in spec
- Do not copy binaries to /sbin but move+link them (should go away when dracut is mandatory)

* Mon Dec 05 2011 fwang <fwang> 4.96-2.mga2
+ Revision: 176816
- new version 4.96
- drop all .la files
- br systemd
- br readline
- new version 4.95
+ colin <colin>
- New version: 4.96 (fixed 100%% CPU on bluetoothd)
- Drop hal BR. No longer needed
+ misc <misc>
- fix systemd patch, taken from Mandriva, made by Funda wang
- new version 4.94
- remove old obsoletes ( likely no longer needed )
- remove old %%clean section
- clean %%defattr, clean old comments
- remove obsoletes dating back to october 2008
- fix requires

* Wed Apr 27 2011 mikala <mikala> 4.92-1.mga1
+ Revision: 92032
- Update tarball to 4.92

* Mon Apr 18 2011 misc <misc> 4.91-1.mga1
+ Revision: 87663
- update to 4.91

* Sat Feb 26 2011 eandry <eandry> 4.89-1.mga1
+ Revision: 60766
- New version 4.89

* Sun Jan 30 2011 dmorgan <dmorgan> 4.87-1.mga1
+ Revision: 44751
- Fix patch 101
- Merge mdv commits :
  634082
  634090
  634124
- Update to version 4.87

* Sat Jan 15 2011 blino <blino> 4.79-2.mga1
+ Revision: 18786
- remove old trigger
+ eandry <eandry>
- imported package bluez

